<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for src/project/config.py: 96%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">
<div id="header">
    <div class="content">
        <h1>Coverage for <b>src/project/config.py</b> :
            <span class="pc_cov">96%</span>
        </h1>
        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />
        <h2 class="stats">
            132 statements &nbsp;
            <button type="button" class="run shortkey_r button_toggle_run" title="Toggle lines run">127 run</button>
            <button type="button" class="mis show_mis shortkey_m button_toggle_mis" title="Toggle lines missing">5 missing</button>
            <button type="button" class="exc show_exc shortkey_x button_toggle_exc" title="Toggle lines excluded">0 excluded</button>
        </h2>
    </div>
</div>
<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>
<div id="source">
    <p id="t1" class="run"><span class="n"><a href="#t1">1</a></span><span class="t"><span class="key">from</span> <span class="nam">project</span> <span class="key">import</span> <span class="nam">app</span>&nbsp;</span><span class="r"></span></p>
    <p id="t2" class="run"><span class="n"><a href="#t2">2</a></span><span class="t"><span class="key">from</span> <span class="nam">project</span><span class="op">.</span><span class="nam">userInfo</span> <span class="key">import</span> <span class="nam">user</span>&nbsp;</span><span class="r"></span></p>
    <p id="t3" class="run"><span class="n"><a href="#t3">3</a></span><span class="t"><span class="key">from</span> <span class="nam">project</span><span class="op">.</span><span class="nam">database</span> <span class="key">import</span> <span class="nam">database</span>&nbsp;</span><span class="r"></span></p>
    <p id="t4" class="run"><span class="n"><a href="#t4">4</a></span><span class="t"><span class="key">from</span> <span class="nam">flask</span> <span class="key">import</span> <span class="nam">Flask</span><span class="op">,</span> <span class="nam">Response</span><span class="op">,</span><span class="nam">redirect</span><span class="op">,</span><span class="nam">render_template</span><span class="op">,</span> <span class="nam">request</span><span class="op">,</span> <span class="nam">jsonify</span><span class="op">,</span><span class="nam">url_for</span><span class="op">,</span> <span class="nam">session</span><span class="op">,</span><span class="nam">escape</span>&nbsp;</span><span class="r"></span></p>
    <p id="t5" class="run"><span class="n"><a href="#t5">5</a></span><span class="t"><span class="key">import</span> <span class="nam">requests</span>&nbsp;</span><span class="r"></span></p>
    <p id="t6" class="run"><span class="n"><a href="#t6">6</a></span><span class="t"><span class="key">import</span> <span class="nam">json</span>&nbsp;</span><span class="r"></span></p>
    <p id="t7" class="pln"><span class="n"><a href="#t7">7</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t8" class="run"><span class="n"><a href="#t8">8</a></span><span class="t"><span class="nam">app</span><span class="op">.</span><span class="nam">secret_key</span> <span class="op">=</span> <span class="str">"molon labe"</span>&nbsp;</span><span class="r"></span></p>
    <p id="t9" class="pln"><span class="n"><a href="#t9">9</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t10" class="pln"><span class="n"><a href="#t10">10</a></span><span class="t"><span class="com"># login function</span>&nbsp;</span><span class="r"></span></p>
    <p id="t11" class="run"><span class="n"><a href="#t11">11</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">'/login'</span><span class="op">,</span> <span class="nam">methods</span><span class="op">=</span><span class="op">[</span><span class="str">'GET'</span><span class="op">,</span> <span class="str">'POST'</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t12" class="pln"><span class="n"><a href="#t12">12</a></span><span class="t"><span class="key">def</span> <span class="nam">login</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t13" class="run"><span class="n"><a href="#t13">13</a></span><span class="t">        <span class="nam">args</span><span class="op">=</span><span class="op">{</span><span class="str">"id"</span><span class="op">:</span> <span class="str">"login"</span><span class="op">,</span> <span class="str">"title"</span><span class="op">:</span> <span class="str">"Micro Service App"</span><span class="op">}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t14" class="run"><span class="n"><a href="#t14">14</a></span><span class="t">        <span class="nam">if_exists</span> <span class="op">=</span> <span class="key">True</span>&nbsp;</span><span class="r"></span></p>
    <p id="t15" class="run"><span class="n"><a href="#t15">15</a></span><span class="t">        <span class="nam">usr_values</span><span class="op">=</span><span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t16" class="pln"><span class="n"><a href="#t16">16</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t17" class="run"><span class="n"><a href="#t17">17</a></span><span class="t">        <span class="key">if</span> <span class="nam">request</span><span class="op">.</span><span class="nam">method</span> <span class="op">==</span> <span class="str">'POST'</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t18" class="run"><span class="n"><a href="#t18">18</a></span><span class="t">                <span class="nam">email</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">form</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="str">'email'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t19" class="run"><span class="n"><a href="#t19">19</a></span><span class="t">                <span class="nam">password</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">form</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="str">'password'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t20" class="run"><span class="n"><a href="#t20">20</a></span><span class="t">                <span class="nam">usr</span> <span class="op">=</span> <span class="nam">app</span><span class="op">.</span><span class="nam">config</span><span class="op">[</span><span class="str">'User'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t21" class="run"><span class="n"><a href="#t21">21</a></span><span class="t">                <span class="nam">usr</span><span class="op">.</span><span class="nam">email</span> <span class="op">=</span> <span class="nam">email</span>&nbsp;</span><span class="r"></span></p>
    <p id="t22" class="run"><span class="n"><a href="#t22">22</a></span><span class="t">                <span class="nam">usr</span><span class="op">.</span><span class="nam">password</span><span class="op">=</span><span class="nam">password</span>&nbsp;</span><span class="r"></span></p>
    <p id="t23" class="run"><span class="n"><a href="#t23">23</a></span><span class="t">                <span class="nam">if_exists</span><span class="op">,</span><span class="nam">usr_values</span> <span class="op">=</span> <span class="nam">usr</span><span class="op">.</span><span class="nam">check_if_exist</span><span class="op">(</span><span class="nam">usr</span><span class="op">.</span><span class="nam">email</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t24" class="pln"><span class="n"><a href="#t24">24</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t25" class="run"><span class="n"><a href="#t25">25</a></span><span class="t">                <span class="key">if</span> <span class="nam">if_exists</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t26" class="run"><span class="n"><a href="#t26">26</a></span><span class="t">                        <span class="key">if</span> <span class="nam">usr_values</span><span class="op">[</span><span class="str">"password"</span><span class="op">]</span> <span class="op">==</span> <span class="nam">usr</span><span class="op">.</span><span class="nam">password</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t27" class="pln"><span class="n"><a href="#t27">27</a></span><span class="t">                                <span class="com"># save the users first name</span>&nbsp;</span><span class="r"></span></p>
    <p id="t28" class="run"><span class="n"><a href="#t28">28</a></span><span class="t">                                <span class="nam">usr</span><span class="op">.</span><span class="nam">first_name</span> <span class="op">=</span> <span class="nam">usr_values</span><span class="op">[</span><span class="str">"first_name"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t29" class="run"><span class="n"><a href="#t29">29</a></span><span class="t">                                <span class="nam">info</span> <span class="op">=</span> <span class="nam">usr</span><span class="op">.</span><span class="nam">first_name</span>&nbsp;</span><span class="r"></span></p>
    <p id="t30" class="pln"><span class="n"><a href="#t30">30</a></span><span class="t">                                <span class="com"># session</span>&nbsp;</span><span class="r"></span></p>
    <p id="t31" class="run"><span class="n"><a href="#t31">31</a></span><span class="t">                                <span class="nam">session</span><span class="op">[</span><span class="str">"email"</span><span class="op">]</span> <span class="op">=</span> <span class="nam">usr</span><span class="op">.</span><span class="nam">email</span>&nbsp;</span><span class="r"></span></p>
    <p id="t32" class="pln"><span class="n"><a href="#t32">32</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t33" class="run"><span class="n"><a href="#t33">33</a></span><span class="t">                                <span class="key">return</span> <span class="nam">redirect</span><span class="op">(</span><span class="nam">url_for</span><span class="op">(</span><span class="str">'home'</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t34" class="pln"><span class="n"><a href="#t34">34</a></span><span class="t">                        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t35" class="run"><span class="n"><a href="#t35">35</a></span><span class="t">                                <span class="nam">args</span><span class="op">[</span><span class="str">"error_message"</span><span class="op">]</span> <span class="op">=</span> <span class="str">'Incorrect password, try again.'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t36" class="run"><span class="n"><a href="#t36">36</a></span><span class="t">                                <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">"login.html"</span><span class="op">,</span><span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t37" class="pln"><span class="n"><a href="#t37">37</a></span><span class="t">                <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t38" class="run"><span class="n"><a href="#t38">38</a></span><span class="t">                        <span class="nam">args</span><span class="op">[</span><span class="str">"error_message"</span><span class="op">]</span> <span class="op">=</span> <span class="str">'Email does not exist.'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t39" class="run"><span class="n"><a href="#t39">39</a></span><span class="t">                        <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">"login.html"</span><span class="op">,</span><span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t40" class="run"><span class="n"><a href="#t40">40</a></span><span class="t">        <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">"login.html"</span><span class="op">,</span><span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t41" class="pln"><span class="n"><a href="#t41">41</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t42" class="pln"><span class="n"><a href="#t42">42</a></span><span class="t"><span class="com">#  logout function</span>&nbsp;</span><span class="r"></span></p>
    <p id="t43" class="run"><span class="n"><a href="#t43">43</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">'/logout'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t44" class="pln"><span class="n"><a href="#t44">44</a></span><span class="t"><span class="key">def</span> <span class="nam">logout</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t45" class="run"><span class="n"><a href="#t45">45</a></span><span class="t">        <span class="nam">args</span><span class="op">=</span><span class="op">{</span><span class="str">"id"</span><span class="op">:</span> <span class="str">"logout"</span><span class="op">,</span> <span class="str">"title"</span><span class="op">:</span> <span class="str">"Micro Service App"</span><span class="op">}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t46" class="run"><span class="n"><a href="#t46">46</a></span><span class="t">        <span class="nam">session</span><span class="op">.</span><span class="nam">pop</span><span class="op">(</span><span class="str">'email'</span><span class="op">,</span> <span class="key">None</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t47" class="run"><span class="n"><a href="#t47">47</a></span><span class="t">        <span class="key">return</span> <span class="nam">redirect</span><span class="op">(</span><span class="nam">url_for</span><span class="op">(</span><span class="str">'home'</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t48" class="pln"><span class="n"><a href="#t48">48</a></span><span class="t">        <span class="com"># return render_template("login.html",args=args)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t49" class="pln"><span class="n"><a href="#t49">49</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t50" class="pln"><span class="n"><a href="#t50">50</a></span><span class="t"><span class="com"># sign-up function</span>&nbsp;</span><span class="r"></span></p>
    <p id="t51" class="run"><span class="n"><a href="#t51">51</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">'/sign_up'</span><span class="op">,</span> <span class="nam">methods</span><span class="op">=</span><span class="op">[</span><span class="str">'GET'</span><span class="op">,</span> <span class="str">'POST'</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t52" class="pln"><span class="n"><a href="#t52">52</a></span><span class="t"><span class="key">def</span> <span class="nam">sign_up</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t53" class="run"><span class="n"><a href="#t53">53</a></span><span class="t">        <span class="nam">args</span><span class="op">=</span><span class="op">{</span><span class="str">"id"</span><span class="op">:</span> <span class="str">"sign_up"</span><span class="op">,</span> <span class="str">"title"</span><span class="op">:</span> <span class="str">"Micro Service App"</span><span class="op">}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t54" class="run"><span class="n"><a href="#t54">54</a></span><span class="t">        <span class="nam">args</span><span class="op">[</span><span class="str">"is_authenticated"</span><span class="op">]</span> <span class="op">=</span> <span class="key">False</span>&nbsp;</span><span class="r"></span></p>
    <p id="t55" class="run"><span class="n"><a href="#t55">55</a></span><span class="t">        <span class="key">if</span> <span class="nam">request</span><span class="op">.</span><span class="nam">method</span> <span class="op">==</span> <span class="str">'POST'</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t56" class="run"><span class="n"><a href="#t56">56</a></span><span class="t">                <span class="nam">email</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">form</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="str">'email'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t57" class="run"><span class="n"><a href="#t57">57</a></span><span class="t">                <span class="nam">first_name</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">form</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="str">'first_name'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t58" class="run"><span class="n"><a href="#t58">58</a></span><span class="t">                <span class="nam">password1</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">form</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="str">'password1'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t59" class="run"><span class="n"><a href="#t59">59</a></span><span class="t">                <span class="nam">password2</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">form</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="str">'password2'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t60" class="run"><span class="n"><a href="#t60">60</a></span><span class="t">                <span class="nam">success</span> <span class="op">=</span><span class="str">""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t61" class="run"><span class="n"><a href="#t61">61</a></span><span class="t">                <span class="nam">args</span><span class="op">[</span><span class="str">"error_message"</span><span class="op">]</span><span class="op">=</span><span class="str">""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t62" class="run"><span class="n"><a href="#t62">62</a></span><span class="t">                <span class="nam">if_exists</span> <span class="op">=</span> <span class="key">True</span>&nbsp;</span><span class="r"></span></p>
    <p id="t63" class="run"><span class="n"><a href="#t63">63</a></span><span class="t">                <span class="nam">usr_values</span><span class="op">=</span><span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t64" class="run"><span class="n"><a href="#t64">64</a></span><span class="t">                <span class="nam">usr</span> <span class="op">=</span> <span class="nam">app</span><span class="op">.</span><span class="nam">config</span><span class="op">[</span><span class="str">'User'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t65" class="pln"><span class="n"><a href="#t65">65</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t66" class="run"><span class="n"><a href="#t66">66</a></span><span class="t">                <span class="nam">if_exists</span><span class="op">,</span><span class="nam">usr_values</span> <span class="op">=</span> <span class="nam">usr</span><span class="op">.</span><span class="nam">check_if_exist</span><span class="op">(</span><span class="nam">email</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t67" class="pln"><span class="n"><a href="#t67">67</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t68" class="run"><span class="n"><a href="#t68">68</a></span><span class="t">                <span class="key">if</span> <span class="nam">if_exists</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t69" class="run"><span class="n"><a href="#t69">69</a></span><span class="t">                        <span class="nam">args</span><span class="op">[</span><span class="str">"error_message"</span><span class="op">]</span> <span class="op">=</span> <span class="str">'Email already exists.'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t70" class="run"><span class="n"><a href="#t70">70</a></span><span class="t">                        <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">"sign_up.html"</span><span class="op">,</span><span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t71" class="run"><span class="n"><a href="#t71">71</a></span><span class="t">                <span class="key">elif</span> <span class="nam">len</span><span class="op">(</span><span class="nam">email</span><span class="op">)</span> <span class="op">&lt;</span> <span class="num">4</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t72" class="run"><span class="n"><a href="#t72">72</a></span><span class="t">                        <span class="nam">args</span><span class="op">[</span><span class="str">"error_message"</span><span class="op">]</span> <span class="op">=</span> <span class="str">'Email must be greater than 3 characters.'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t73" class="run"><span class="n"><a href="#t73">73</a></span><span class="t">                        <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">"sign_up.html"</span><span class="op">,</span><span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t74" class="run"><span class="n"><a href="#t74">74</a></span><span class="t">                <span class="key">elif</span> <span class="nam">password1</span> <span class="op">!=</span> <span class="nam">password2</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t75" class="run"><span class="n"><a href="#t75">75</a></span><span class="t">                        <span class="nam">args</span><span class="op">[</span><span class="str">"error_message"</span><span class="op">]</span> <span class="op">=</span> <span class="str">'Password must be the same.'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t76" class="run"><span class="n"><a href="#t76">76</a></span><span class="t">                        <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">"sign_up.html"</span><span class="op">,</span><span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t77" class="run"><span class="n"><a href="#t77">77</a></span><span class="t">                <span class="key">elif</span> <span class="nam">len</span><span class="op">(</span><span class="nam">password1</span><span class="op">)</span> <span class="op">&lt;</span> <span class="num">7</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t78" class="run"><span class="n"><a href="#t78">78</a></span><span class="t">                        <span class="nam">args</span><span class="op">[</span><span class="str">"error_message"</span><span class="op">]</span> <span class="op">=</span> <span class="str">'Password must be at least 7 characters.'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t79" class="run"><span class="n"><a href="#t79">79</a></span><span class="t">                        <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">"sign_up.html"</span><span class="op">,</span><span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t80" class="pln"><span class="n"><a href="#t80">80</a></span><span class="t">                <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t81" class="run"><span class="n"><a href="#t81">81</a></span><span class="t">                        <span class="nam">usr</span><span class="op">.</span><span class="nam">email</span> <span class="op">=</span> <span class="nam">email</span>&nbsp;</span><span class="r"></span></p>
    <p id="t82" class="run"><span class="n"><a href="#t82">82</a></span><span class="t">                        <span class="nam">usr</span><span class="op">.</span><span class="nam">first_name</span> <span class="op">=</span> <span class="nam">first_name</span>&nbsp;</span><span class="r"></span></p>
    <p id="t83" class="run"><span class="n"><a href="#t83">83</a></span><span class="t">                        <span class="nam">usr</span><span class="op">.</span><span class="nam">password</span> <span class="op">=</span> <span class="nam">password1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t84" class="run"><span class="n"><a href="#t84">84</a></span><span class="t">                        <span class="nam">success</span> <span class="op">=</span> <span class="nam">usr</span><span class="op">.</span><span class="nam">save_to_db</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t85" class="pln"><span class="n"><a href="#t85">85</a></span><span class="t">                        <span class="com"># session</span>&nbsp;</span><span class="r"></span></p>
    <p id="t86" class="run"><span class="n"><a href="#t86">86</a></span><span class="t">                        <span class="nam">session</span><span class="op">[</span><span class="str">"email"</span><span class="op">]</span> <span class="op">=</span> <span class="nam">usr</span><span class="op">.</span><span class="nam">email</span>&nbsp;</span><span class="r"></span></p>
    <p id="t87" class="pln"><span class="n"><a href="#t87">87</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t88" class="run"><span class="n"><a href="#t88">88</a></span><span class="t">                        <span class="key">return</span> <span class="nam">redirect</span><span class="op">(</span><span class="nam">url_for</span><span class="op">(</span><span class="str">'home'</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t89" class="pln"><span class="n"><a href="#t89">89</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t90" class="run"><span class="n"><a href="#t90">90</a></span><span class="t">        <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">"sign_up.html"</span><span class="op">,</span><span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t91" class="pln"><span class="n"><a href="#t91">91</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t92" class="run"><span class="n"><a href="#t92">92</a></span><span class="t"><span class="key">def</span> <span class="nam">get_session_user</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t93" class="run"><span class="n"><a href="#t93">93</a></span><span class="t">        <span class="nam">usr</span> <span class="op">=</span> <span class="nam">app</span><span class="op">.</span><span class="nam">config</span><span class="op">[</span><span class="str">'User'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t94" class="run"><span class="n"><a href="#t94">94</a></span><span class="t">        <span class="key">if</span> <span class="str">'email'</span> <span class="key">not</span> <span class="key">in</span> <span class="nam">session</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t95" class="run"><span class="n"><a href="#t95">95</a></span><span class="t">                <span class="key">return</span> <span class="key">None</span>&nbsp;</span><span class="r"></span></p>
    <p id="t96" class="run"><span class="n"><a href="#t96">96</a></span><span class="t">        <span class="nam">email</span> <span class="op">=</span> <span class="nam">session</span><span class="op">[</span><span class="str">'email'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t97" class="run"><span class="n"><a href="#t97">97</a></span><span class="t">        <span class="nam">user</span> <span class="op">=</span> <span class="nam">usr</span><span class="op">.</span><span class="nam">get_user_by_email</span><span class="op">(</span><span class="nam">email</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t98" class="run"><span class="n"><a href="#t98">98</a></span><span class="t">        <span class="key">return</span> <span class="nam">user</span>&nbsp;</span><span class="r"></span></p>
    <p id="t99" class="pln"><span class="n"><a href="#t99">99</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t100" class="run"><span class="n"><a href="#t100">100</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t101" class="pln"><span class="n"><a href="#t101">101</a></span><span class="t"><span class="key">def</span> <span class="nam">home</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t102" class="run"><span class="n"><a href="#t102">102</a></span><span class="t">        <span class="nam">usr_session</span> <span class="op">=</span> <span class="nam">app</span><span class="op">.</span><span class="nam">config</span><span class="op">[</span><span class="str">'User'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t103" class="run"><span class="n"><a href="#t103">103</a></span><span class="t">        <span class="nam">user</span> <span class="op">=</span> <span class="nam">get_session_user</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t104" class="run"><span class="n"><a href="#t104">104</a></span><span class="t">        <span class="key">if</span> <span class="nam">user</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t105" class="run"><span class="n"><a href="#t105">105</a></span><span class="t">                <span class="nam">usr_session</span><span class="op">.</span><span class="nam">email</span> <span class="op">=</span> <span class="nam">user</span><span class="op">[</span><span class="str">"email"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t106" class="run"><span class="n"><a href="#t106">106</a></span><span class="t">                <span class="nam">usr_session</span><span class="op">.</span><span class="nam">first_name</span> <span class="op">=</span> <span class="nam">user</span><span class="op">[</span><span class="str">"first_name"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t107" class="run"><span class="n"><a href="#t107">107</a></span><span class="t">                <span class="nam">args</span><span class="op">=</span><span class="op">{</span><span class="str">"id"</span><span class="op">:</span> <span class="str">"msa"</span><span class="op">,</span> <span class="str">"title"</span><span class="op">:</span> <span class="str">"Micro Service App"</span><span class="op">,</span> <span class="str">"first_name"</span><span class="op">:</span> <span class="nam">usr_session</span><span class="op">.</span><span class="nam">first_name</span><span class="op">}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t108" class="pln"><span class="n"><a href="#t108">108</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t109" class="run"><span class="n"><a href="#t109">109</a></span><span class="t">                <span class="nam">args</span><span class="op">=</span><span class="op">{</span><span class="str">"id"</span><span class="op">:</span> <span class="str">"msa"</span><span class="op">,</span> <span class="str">"title"</span><span class="op">:</span> <span class="str">"Micro Service App"</span><span class="op">}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t110" class="pln"><span class="n"><a href="#t110">110</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t111" class="run"><span class="n"><a href="#t111">111</a></span><span class="t">        <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">'msa.html'</span><span class="op">,</span> <span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t112" class="pln"><span class="n"><a href="#t112">112</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t113" class="pln"><span class="n"><a href="#t113">113</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t114" class="run"><span class="n"><a href="#t114">114</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/marketSummaries"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t115" class="pln"><span class="n"><a href="#t115">115</a></span><span class="t"><span class="key">def</span> <span class="nam">all_market_summaries</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t116" class="run"><span class="n"><a href="#t116">116</a></span><span class="t">        <span class="nam">db</span> <span class="op">=</span> <span class="nam">app</span><span class="op">.</span><span class="nam">config</span><span class="op">[</span><span class="str">'MarketSummaries'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t117" class="run"><span class="n"><a href="#t117">117</a></span><span class="t">        <span class="nam">ac</span> <span class="op">=</span> <span class="nam">app</span><span class="op">.</span><span class="nam">config</span><span class="op">[</span><span class="str">'ApiCalls'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t118" class="pln"><span class="n"><a href="#t118">118</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t119" class="pln"><span class="n"><a href="#t119">119</a></span><span class="t">        <span class="com"># check if session</span>&nbsp;</span><span class="r"></span></p>
    <p id="t120" class="run"><span class="n"><a href="#t120">120</a></span><span class="t">        <span class="nam">usr_session</span> <span class="op">=</span> <span class="nam">app</span><span class="op">.</span><span class="nam">config</span><span class="op">[</span><span class="str">'User'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t121" class="run"><span class="n"><a href="#t121">121</a></span><span class="t">        <span class="nam">user</span> <span class="op">=</span> <span class="nam">get_session_user</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t122" class="run"><span class="n"><a href="#t122">122</a></span><span class="t">        <span class="key">if</span> <span class="nam">user</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t123" class="run"><span class="n"><a href="#t123">123</a></span><span class="t">                <span class="nam">usr_session</span><span class="op">.</span><span class="nam">email</span> <span class="op">=</span> <span class="nam">user</span><span class="op">[</span><span class="str">"email"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t124" class="run"><span class="n"><a href="#t124">124</a></span><span class="t">                <span class="nam">usr_session</span><span class="op">.</span><span class="nam">first_name</span> <span class="op">=</span> <span class="nam">user</span><span class="op">[</span><span class="str">"first_name"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t125" class="run"><span class="n"><a href="#t125">125</a></span><span class="t">                <span class="nam">args</span><span class="op">=</span><span class="op">{</span> <span class="str">"id"</span><span class="op">:</span> <span class="str">"marketSummaries"</span><span class="op">,</span> <span class="str">"title"</span><span class="op">:</span> <span class="str">"All Market Summaries"</span><span class="op">,</span> <span class="str">"first_name"</span><span class="op">:</span> <span class="nam">usr_session</span><span class="op">.</span><span class="nam">first_name</span><span class="op">}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t126" class="pln"><span class="n"><a href="#t126">126</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t127" class="run"><span class="n"><a href="#t127">127</a></span><span class="t">                <span class="nam">args</span><span class="op">[</span><span class="str">"headers"</span><span class="op">]</span> <span class="op">=</span> <span class="op">[</span><span class="str">"Market Name"</span><span class="op">,</span><span class="str">"High"</span><span class="op">,</span><span class="str">"Low"</span><span class="op">,</span><span class="str">"Volume"</span><span class="op">,</span><span class="str">"Last"</span><span class="op">,</span><span class="str">"Base Volume"</span><span class="op">,</span> <span class="str">"Time Stamp"</span><span class="op">,</span><span class="str">"Bid"</span><span class="op">,</span> <span class="str">" Ask"</span><span class="op">,</span> <span class="str">"Open Buy Orders"</span><span class="op">,</span><span class="str">"Open Sell Orders"</span><span class="op">,</span> <span class="str">" Prev. Day"</span><span class="op">,</span> <span class="str">"Created"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t128" class="run"><span class="n"><a href="#t128">128</a></span><span class="t">                <span class="nam">args</span><span class="op">[</span><span class="str">"marketSummary"</span><span class="op">]</span> <span class="op">=</span> <span class="str">""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t129" class="run"><span class="n"><a href="#t129">129</a></span><span class="t">                <span class="nam">args</span><span class="op">[</span><span class="str">'success_insert'</span><span class="op">]</span> <span class="op">=</span><span class="str">""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t130" class="run"><span class="n"><a href="#t130">130</a></span><span class="t">                <span class="nam">args</span><span class="op">[</span><span class="str">'success'</span><span class="op">]</span> <span class="op">=</span> <span class="key">True</span>&nbsp;</span><span class="r"></span></p>
    <p id="t131" class="pln"><span class="n"><a href="#t131">131</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t132" class="pln"><span class="n"><a href="#t132">132</a></span><span class="t">                <span class="com"># first api request to retrieve all market summaries</span>&nbsp;</span><span class="r"></span></p>
    <p id="t133" class="run"><span class="n"><a href="#t133">133</a></span><span class="t">                <span class="nam">json_data</span><span class="op">,</span><span class="nam">args</span><span class="op">[</span><span class="str">'success'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">ac</span><span class="op">.</span><span class="nam">all_market_summaries_api</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t134" class="pln"><span class="n"><a href="#t134">134</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t135" class="pln"><span class="n"><a href="#t135">135</a></span><span class="t">                <span class="com"># If successful, response 200   </span>&nbsp;</span><span class="r"></span></p>
    <p id="t136" class="run"><span class="n"><a href="#t136">136</a></span><span class="t">                <span class="key">if</span> <span class="nam">args</span><span class="op">[</span><span class="str">'success'</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t137" class="pln"><span class="n"><a href="#t137">137</a></span><span class="t">                        <span class="com"># insert to database the data</span>&nbsp;</span><span class="r"></span></p>
    <p id="t138" class="run"><span class="n"><a href="#t138">138</a></span><span class="t">                        <span class="nam">rowcount</span> <span class="op">=</span> <span class="nam">db</span><span class="op">.</span><span class="nam">insert_to_database</span><span class="op">(</span><span class="nam">json_data</span><span class="op">[</span><span class="str">"result"</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t139" class="run"><span class="n"><a href="#t139">139</a></span><span class="t">                        <span class="key">if</span> <span class="nam">rowcount</span> <span class="op">></span> <span class="num">0</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t140" class="run"><span class="n"><a href="#t140">140</a></span><span class="t">                                <span class="nam">args</span><span class="op">[</span><span class="str">'success_insert'</span><span class="op">]</span> <span class="op">=</span> <span class="str">"This was a success!!"</span>&nbsp;</span><span class="r"></span></p>
    <p id="t141" class="pln"><span class="n"><a href="#t141">141</a></span><span class="t">                        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t142" class="mis show_mis"><span class="n"><a href="#t142">142</a></span><span class="t">                                <span class="nam">args</span><span class="op">[</span><span class="str">'success_insert'</span><span class="op">]</span> <span class="op">=</span> <span class="str">"This was NOT a success!!"</span>&nbsp;</span><span class="r"></span></p>
    <p id="t143" class="pln"><span class="n"><a href="#t143">143</a></span><span class="t">                        <span class="com"># retrieve from database the data</span>&nbsp;</span><span class="r"></span></p>
    <p id="t144" class="run"><span class="n"><a href="#t144">144</a></span><span class="t">                        <span class="nam">args</span><span class="op">[</span><span class="str">"marketSummary"</span><span class="op">]</span> <span class="op">=</span> <span class="nam">db</span><span class="op">.</span><span class="nam">get_marketSummaries_from_database</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t145" class="pln"><span class="n"><a href="#t145">145</a></span><span class="t">                <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t146" class="pln"><span class="n"><a href="#t146">146</a></span><span class="t">                        <span class="com"># if not successful save the error code</span>&nbsp;</span><span class="r"></span></p>
    <p id="t147" class="mis show_mis"><span class="n"><a href="#t147">147</a></span><span class="t">                        <span class="nam">args</span><span class="op">[</span><span class="str">'success_insert'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">json_data</span>&nbsp;</span><span class="r"></span></p>
    <p id="t148" class="pln"><span class="n"><a href="#t148">148</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t149" class="run"><span class="n"><a href="#t149">149</a></span><span class="t">                <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">'marketSummaries.html'</span><span class="op">,</span> <span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t150" class="pln"><span class="n"><a href="#t150">150</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t151" class="run"><span class="n"><a href="#t151">151</a></span><span class="t">                <span class="nam">args</span><span class="op">=</span><span class="op">{</span><span class="str">"id"</span><span class="op">:</span> <span class="str">"msa"</span><span class="op">,</span> <span class="str">"title"</span><span class="op">:</span> <span class="str">"Micro Service App"</span><span class="op">}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t152" class="run"><span class="n"><a href="#t152">152</a></span><span class="t">                <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">'msa.html'</span><span class="op">,</span> <span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t153" class="pln"><span class="n"><a href="#t153">153</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t154" class="pln"><span class="n"><a href="#t154">154</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t155" class="run"><span class="n"><a href="#t155">155</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/specificMarketSummary"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t156" class="pln"><span class="n"><a href="#t156">156</a></span><span class="t"><span class="key">def</span> <span class="nam">specific_market_summary</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t157" class="pln"><span class="n"><a href="#t157">157</a></span><span class="t">        <span class="com"># the API authentication without the param.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t158" class="run"><span class="n"><a href="#t158">158</a></span><span class="t">        <span class="nam">db</span> <span class="op">=</span> <span class="nam">app</span><span class="op">.</span><span class="nam">config</span><span class="op">[</span><span class="str">'MarketSummaries'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t159" class="run"><span class="n"><a href="#t159">159</a></span><span class="t">        <span class="nam">ac</span> <span class="op">=</span> <span class="nam">app</span><span class="op">.</span><span class="nam">config</span><span class="op">[</span><span class="str">'ApiCalls'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t160" class="pln"><span class="n"><a href="#t160">160</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t161" class="pln"><span class="n"><a href="#t161">161</a></span><span class="t">        <span class="com"># check if session</span>&nbsp;</span><span class="r"></span></p>
    <p id="t162" class="run"><span class="n"><a href="#t162">162</a></span><span class="t">        <span class="nam">usr_session</span> <span class="op">=</span> <span class="nam">app</span><span class="op">.</span><span class="nam">config</span><span class="op">[</span><span class="str">'User'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t163" class="run"><span class="n"><a href="#t163">163</a></span><span class="t">        <span class="nam">user</span> <span class="op">=</span> <span class="nam">get_session_user</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t164" class="run"><span class="n"><a href="#t164">164</a></span><span class="t">        <span class="key">if</span> <span class="nam">user</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t165" class="run"><span class="n"><a href="#t165">165</a></span><span class="t">                <span class="nam">usr_session</span><span class="op">.</span><span class="nam">email</span> <span class="op">=</span> <span class="nam">user</span><span class="op">[</span><span class="str">"email"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t166" class="run"><span class="n"><a href="#t166">166</a></span><span class="t">                <span class="nam">usr_session</span><span class="op">.</span><span class="nam">first_name</span> <span class="op">=</span> <span class="nam">user</span><span class="op">[</span><span class="str">"first_name"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t167" class="pln"><span class="n"><a href="#t167">167</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t168" class="run"><span class="n"><a href="#t168">168</a></span><span class="t">                <span class="nam">args</span><span class="op">=</span><span class="op">{</span> <span class="str">"id"</span><span class="op">:</span> <span class="str">"specificMarketSummary"</span><span class="op">,</span> <span class="str">"title"</span><span class="op">:</span> <span class="str">"Specific Market Summary"</span><span class="op">,</span> <span class="str">"first_name"</span><span class="op">:</span> <span class="nam">usr_session</span><span class="op">.</span><span class="nam">first_name</span><span class="op">}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t169" class="run"><span class="n"><a href="#t169">169</a></span><span class="t">                <span class="nam">args</span><span class="op">[</span><span class="str">"headers"</span><span class="op">]</span> <span class="op">=</span> <span class="op">[</span><span class="str">"Market Name"</span><span class="op">,</span><span class="str">"High"</span><span class="op">,</span><span class="str">"Low"</span><span class="op">,</span><span class="str">"Volume"</span><span class="op">,</span><span class="str">"Last"</span><span class="op">,</span><span class="str">"Base Volume"</span><span class="op">,</span> <span class="str">"Time Stamp"</span><span class="op">,</span><span class="str">"Bid"</span><span class="op">,</span> <span class="str">" Ask"</span><span class="op">,</span> <span class="str">"Open Buy Orders"</span><span class="op">,</span><span class="str">"Open Sell Orders"</span><span class="op">,</span> <span class="str">" Prev. Day"</span><span class="op">,</span> <span class="str">"Created"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t170" class="run"><span class="n"><a href="#t170">170</a></span><span class="t">                <span class="nam">args</span><span class="op">[</span><span class="str">"market"</span><span class="op">]</span> <span class="op">=</span> <span class="str">""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t171" class="run"><span class="n"><a href="#t171">171</a></span><span class="t">                <span class="nam">args</span><span class="op">[</span><span class="str">"marketSummary"</span><span class="op">]</span><span class="op">=</span><span class="str">""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t172" class="run"><span class="n"><a href="#t172">172</a></span><span class="t">                <span class="nam">args</span><span class="op">[</span><span class="str">"message"</span><span class="op">]</span><span class="op">=</span><span class="str">""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t173" class="run"><span class="n"><a href="#t173">173</a></span><span class="t">                <span class="nam">args</span><span class="op">[</span><span class="str">'success_insert'</span><span class="op">]</span> <span class="op">=</span><span class="str">""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t174" class="run"><span class="n"><a href="#t174">174</a></span><span class="t">                <span class="nam">args</span><span class="op">[</span><span class="str">'success'</span><span class="op">]</span> <span class="op">=</span> <span class="key">True</span>&nbsp;</span><span class="r"></span></p>
    <p id="t175" class="pln"><span class="n"><a href="#t175">175</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t176" class="pln"><span class="n"><a href="#t176">176</a></span><span class="t">                <span class="com"># get the param.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t177" class="run"><span class="n"><a href="#t177">177</a></span><span class="t">                <span class="key">if</span> <span class="str">"market"</span> <span class="key">in</span> <span class="nam">request</span><span class="op">.</span><span class="nam">args</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t178" class="run"><span class="n"><a href="#t178">178</a></span><span class="t">                        <span class="nam">args</span><span class="op">[</span><span class="str">"market"</span><span class="op">]</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">args</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="str">"market"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t179" class="pln"><span class="n"><a href="#t179">179</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t180" class="pln"><span class="n"><a href="#t180">180</a></span><span class="t">                        <span class="com"># second api request to retrieve the specific market summary</span>&nbsp;</span><span class="r"></span></p>
    <p id="t181" class="run"><span class="n"><a href="#t181">181</a></span><span class="t">                        <span class="nam">json_data</span><span class="op">,</span><span class="nam">message</span><span class="op">,</span><span class="nam">args</span><span class="op">[</span><span class="str">'success'</span><span class="op">]</span><span class="op">=</span> <span class="nam">ac</span><span class="op">.</span><span class="nam">market_summary_api</span><span class="op">(</span><span class="nam">args</span><span class="op">[</span><span class="str">"market"</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t182" class="pln"><span class="n"><a href="#t182">182</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t183" class="pln"><span class="n"><a href="#t183">183</a></span><span class="t">                        <span class="com"># check if we got a success response</span>&nbsp;</span><span class="r"></span></p>
    <p id="t184" class="run"><span class="n"><a href="#t184">184</a></span><span class="t">                        <span class="key">if</span> <span class="nam">args</span><span class="op">[</span><span class="str">"success"</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t185" class="run"><span class="n"><a href="#t185">185</a></span><span class="t">                                <span class="nam">args</span><span class="op">[</span><span class="str">"marketSummary"</span><span class="op">]</span> <span class="op">=</span> <span class="nam">db</span><span class="op">.</span><span class="nam">getValuesFromResults</span><span class="op">(</span><span class="nam">json_data</span><span class="op">[</span><span class="str">"result"</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t186" class="pln"><span class="n"><a href="#t186">186</a></span><span class="t">                        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t187" class="mis show_mis"><span class="n"><a href="#t187">187</a></span><span class="t">                                <span class="key">if</span> <span class="nam">message</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t188" class="mis show_mis"><span class="n"><a href="#t188">188</a></span><span class="t">                                        <span class="nam">args</span><span class="op">[</span><span class="str">"message"</span><span class="op">]</span> <span class="op">=</span> <span class="nam">json_data</span><span class="op">[</span><span class="str">"message"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t189" class="pln"><span class="n"><a href="#t189">189</a></span><span class="t">                                <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t190" class="pln"><span class="n"><a href="#t190">190</a></span><span class="t">                                        <span class="com"># if not successful save the error code</span>&nbsp;</span><span class="r"></span></p>
    <p id="t191" class="mis show_mis"><span class="n"><a href="#t191">191</a></span><span class="t">                                        <span class="nam">args</span><span class="op">[</span><span class="str">'success_insert'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">json_data</span>&nbsp;</span><span class="r"></span></p>
    <p id="t192" class="pln"><span class="n"><a href="#t192">192</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t193" class="pln"><span class="n"><a href="#t193">193</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t194" class="run"><span class="n"><a href="#t194">194</a></span><span class="t">                <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">'specificMarketSummary.html'</span><span class="op">,</span> <span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t195" class="pln"><span class="n"><a href="#t195">195</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t196" class="run"><span class="n"><a href="#t196">196</a></span><span class="t">                <span class="nam">args</span><span class="op">=</span><span class="op">{</span><span class="str">"id"</span><span class="op">:</span> <span class="str">"msa"</span><span class="op">,</span> <span class="str">"title"</span><span class="op">:</span> <span class="str">"Micro Service App"</span><span class="op">}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t197" class="run"><span class="n"><a href="#t197">197</a></span><span class="t">                <span class="key">return</span> <span class="nam">render_template</span><span class="op">(</span><span class="str">'msa.html'</span><span class="op">,</span> <span class="nam">args</span><span class="op">=</span><span class="nam">args</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
</div>
<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v5.3</a>,
            created at 2021-12-30 12:07 +0200
        </p>
    </div>
</div>
</body>
</html>
